Imports System.Data
Imports System.Xml
Imports System.Xml.XmlDataDocument
Imports System.Data.OleDb
Imports System.Data.SqlTypes
Imports System.Text
Imports System.IO
Imports System.Threading


Public Class Form1

    Private PlayAgain As Boolean

    ' This is to start the dataset for the music beat sequences
    Dim ds As New DataSet(), dr As DataRow, dt As DataTable

    'Holds a deleted record
    Dim titlehold, descriptionhold, outData, CreateStrg As String

    'Holds the current filename
    Dim schemafilepath, datafilepath As String

    'Holds the total records and current record number
    Dim totalrows, currentrow As Integer

    'Serial Port Enable 
    Public WithEvents SerialPort As New IO.Ports.SerialPort
    Dim a, b, c As Integer

    'Integers for the quick channel buttons 
    Dim c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16 As Integer
    Dim c17, c18, c19, c20, c21, c22, c23, c24, c25, c26, c27, c28, c29, c30, c31, c32 As Integer
    

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' This code enables the startup settings of the Media Player
        AxWindowsMediaPlayer1.settings.autoStart = True
        AxWindowsMediaPlayer1.settings.volume = TrackBar1.Value
        AxWindowsMediaPlayer1.settings.enableErrorDialogs = False
        AxWindowsMediaPlayer1.enableContextMenu = False
        Label2.Text = TrackBar1.Value

        'Create a new table named Sequence with Beat and Channel
        '(the description of the actual Sequence) columns.
        dt = New DataTable("sequence")
        dt.Columns.Add("beat", GetType(String))
        dt.Columns.Add("channel", GetType(String))
        ds.Tables.Add(dt)
        dt = ds.Tables!sequence

        For i As Integer = 0 To _
                 My.Computer.Ports.SerialPortNames.Count - 1
            Port.Items.Add( _
               My.Computer.Ports.SerialPortNames(i))
        Next
        If SerialPort.IsOpen Then
            SerialPort.Close()
        End If
        Baud.Text = "9600"
        Bits.Text = "8"
        Even.CheckState = CheckState.Checked
        Bit1.CheckState = CheckState.Checked
        Flow_None.CheckState = CheckState.Checked
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim CloseMessage As DialogResult
        CloseMessage = MsgBox("    Close Music Sequener Controller?", MsgBoxStyle.YesNo)
        If CloseMessage = Windows.Forms.DialogResult.Yes Then
            AxWindowsMediaPlayer1.Ctlcontrols.stop()
            If SerialPort.IsOpen Then SerialPort.Close() 'Here we close the serial port so it wont lock open
        End If
        If CloseMessage = Windows.Forms.DialogResult.No Then
            e.Cancel = True
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' Search for Channel to set high at each pulse.
        ' Update the trackbar.
        Dim CurPos As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.Ctlcontrols.currentPosition * 1000) ' milliseconds
        Dim DurationVar As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.currentMedia.duration * 1000) ' milliseconds
        If DurationVar > 0 Then
            PlayBar.Value = Convert.ToInt32((CurPos * 91) / DurationVar) ' % complete
        End If

        ' Update the time label
        Dim CurPos1 As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.Ctlcontrols.currentPosition * 8)
        Duration.Text = CurPos1

        'PlayerControl.Ctlcontrols.currentPositionString
        If AxWindowsMediaPlayer1.playState = WMPLib.WMPPlayState.wmppsStopped Then
            Duration.Text = "00:00"
            Timer1.Enabled = False
            PlayBar.Value = 0
        End If
        If PlayAgain = False Then
        Else
            If AxWindowsMediaPlayer1.playState = WMPLib.WMPPlayState.wmppsStopped Then
                PlaySong()
            Else
            End If
        End If

    End Sub

    Private Sub Play_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Play.Click
        PlaySong()
    End Sub

    Private Sub PlaySong()
        'This is the routine for playing a song with windows media player
        If AxWindowsMediaPlayer1.URL <> "" Then
            AxWindowsMediaPlayer1.Ctlcontrols.play()
            Timer1.Enabled = True
        Else
            Timer1.Enabled = False
        End If
        If Play.Text = "Play" Then
            Play.Text = "Playing"
        End If

    End Sub

    Private Sub OpenMusic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenMusic.Click
        GetFile()
    End Sub

    Private Sub GetFile()
        'This is the routine for opening a music file for windows media player
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK And OpenFileDialog1.FileName <> "" Then
            AxWindowsMediaPlayer1.URL = OpenFileDialog1.FileName
            Timer1.Enabled = True
            Label8.Text = OpenFileDialog1.FileName
            Play.Enabled = True
            PlaySong()
        End If
    End Sub

    Private Sub StopButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopButton.Click
        StopSong()
    End Sub

    Private Sub StopSong()
        'Stop routine for windows media player
        AxWindowsMediaPlayer1.Ctlcontrols.stop()
        Duration.Text = "0"
        Timer1.Enabled = False
        PlayBar.Value = 0
        currentrow = 0
        If Play.Text = "Playing" Then
            Play.Text = "Play"
        End If
    End Sub

    Private Sub Pause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Pause.Click
        PauseSong()
    End Sub

    Private Sub PauseSong()
        'Pause routine for windows media player
        AxWindowsMediaPlayer1.Ctlcontrols.pause()
        Timer1.Enabled = False
    End Sub

    Private Sub LookUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LookUp.Click
        up()
    End Sub

    Private Sub up()
        'Row up routine for the xml dataset
        Dim pos As Int64
        Dim pos1 As Int64
        currentrow = currentrow + 1
        pos = totalrows - 1
        If currentrow > pos Then
            pos1 = 0
            currentrow = 0
        Else : pos1 = currentrow
        End If
        If currentrow > 0 Or totalrows Then
            TextBox2.Text = currentrow
            TextBox3.Text = dt.Rows(pos1).Item(0)
            TextBox4.Text = dt.Rows(pos1).Item(1)
        Else
            MsgBox("         No Beats to choose from.")
        End If
    End Sub

    Private Sub LookDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LookDown.Click
        down()
    End Sub

    Private Sub down()
        'Row down routine for the xml dataset
        currentrow = currentrow - 1
        If currentrow = -1 Then
            currentrow = 0
        End If
        TextBox2.Text = currentrow
        If currentrow > 0 Then
            TextBox3.Text = dt.Rows(currentrow).Item(0)
            TextBox4.Text = dt.Rows(currentrow).Item(1)
        End If
    End Sub

    Private Sub Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Delete.Click
        deleterow()
    End Sub

    Private Sub deleterow()
        'Delete routine for the XML dataset
        If totalrows > currentrow Then
            dt.Rows.RemoveAt(currentrow)
            totalrows = dt.Rows.Count
            TextBox1.Text = totalrows
            ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
            ds.WriteXml("c:\" & Label10.Text & "data.xml")
        End If
    End Sub

    Private Sub Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Find.Click
        findchannel()
    End Sub

    Private Sub findchannel()
        'Find the channel to output from the XML dataset routine.
        For Each dr In dt.Rows
            If dr!beat = Duration.Text Then
                TextBox3.Text = dr!beat
                TextBox4.Text = dr!channel
            End If
        Next

    End Sub

    Private Sub Update_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateRow.Click
        UProw()
    End Sub

    Private Sub CreateString()

        If CheckBox1.Checked = True Or c1 = 1 Then
            TextBox6.Text = "1"
        ElseIf CheckBox1.Checked = False Then
            TextBox6.Text = "0"
        End If
        If CheckBox2.Checked = True Or c2 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox2.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox3.Checked = True Or c3 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox3.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox4.Checked = True Or c4 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox4.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox5.Checked = True Or c5 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox5.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox6.Checked = True Or c6 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox6.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox7.Checked = True Or c7 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox7.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox8.Checked = True Or c8 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox8.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox9.Checked = True Or c9 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox9.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox10.Checked = True Or c10 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox10.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox11.Checked = True Or c11 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox11.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox12.Checked = True Or c12 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox12.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox13.Checked = True Or c13 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox13.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox14.Checked = True Or c14 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox14.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox15.Checked = True Or c15 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox15.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox16.Checked = True Or c16 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox16.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox17.Checked = True Or c17 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox17.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox18.Checked = True Or c18 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox18.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox19.Checked = True Or c19 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox19.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox20.Checked = True Or c20 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox20.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox21.Checked = True Or c21 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox21.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox22.Checked = True Or c22 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox22.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox23.Checked = True Or c23 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox23.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox24.Checked = True Or c24 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox24.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox25.Checked = True Or c25 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox25.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox26.Checked = True Or c26 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox26.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox27.Checked = True Or c27 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox27.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox28.Checked = True Or c28 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox28.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox29.Checked = True Or c29 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox29.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox30.Checked = True Or c30 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox30.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox31.Checked = True Or c31 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox31.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox32.Checked = True Or c32 = 1 Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox32.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If

        'This is the String to load the data set with
        CreateStrg = TextBox6.Text

    End Sub

    Private Sub UProw()
        'This is how to update a Row in a Dataset modify the star in (dr,*) too which row you  
        ' want to update.
        currentrow = TextBox3.Text
        replacechannel()
        deleterow()
        CreateString()
        dr = dt.NewRow
        dr!beat = TextBox3.Text
        dr!channel = CreateStrg
        dt.Rows.InsertAt(dr, currentrow)
        ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        ds.WriteXml("c:\" & Label10.Text & "data.xml")
        totalrows = dt.Rows.Count
        TextBox1.Text = totalrows

    End Sub

    Private Sub loadnewrow()
        CreateString()
        dr = dt.NewRow
        dr!beat = Duration.Text
        dr!channel = CreateStrg
        dt.Rows.Add(dr)
        ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        ds.WriteXml("c:\" & Label10.Text & "data.xml")
        totalrows = dt.Rows.Count
        TextBox1.Text = totalrows
    End Sub

    Private Sub OpenSequence_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenSequence.Click
        Form4.Show()
    End Sub

    Private Sub AboutToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem1.Click
        Form3.Show()
    End Sub

    Private Sub OpenSequenceFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenSequenceFileToolStripMenuItem.Click
        Form4.Show()
    End Sub

    Private Sub OpenMusicFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenMusicFileToolStripMenuItem.Click
        GetFile()
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Close()
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        AxWindowsMediaPlayer1.settings.volume = TrackBar1.Value
        Label2.Text = TrackBar1.Value
    End Sub

    Private Sub PlayBar_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles PlayBar.Scroll
        Try
            If (AxWindowsMediaPlayer1.currentMedia.duration <> 0) Then
                Dim NewPerc As Double = Convert.ToDouble(PlayBar.Value) / 100
                Dim DurationVar As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.currentMedia.duration * 100) ' milliseconds
                Dim NewPos As Integer = (DurationVar * NewPerc) / 100
                AxWindowsMediaPlayer1.Ctlcontrols.currentPosition = NewPos
            Else
                PlayBar.Value = 0
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub creatdataset()

        ' This allows you to create a new dataset in the C: drive
        If Not (System.IO.File.Exists("c:\" & Label10.Text & "dataset.xml")) Then
            ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        Else
            MessageBox.Show("File exist already create a different sequence.")
            Form4.delete()
        End If

        'This allows you to create new set of data in the dataset into the C: drive
        If Not (System.IO.File.Exists("c:\" & Label10.Text & "data.xml")) Then
            ds.WriteXml("c:\" & Label10.Text & "data.xml")

        End If

        totalrows = dt.Rows.Count
        currentrow = 0
        TextBox1.Text = totalrows
    End Sub

    Public Sub loaddatasets()
        ' This allows you to read the dataset back from the C: drive
        If Not (System.IO.File.Exists("c:\" & Label10.Text & "dataset.xml")) Then
            ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        Else
            ds.ReadXmlSchema("c:\" & Label10.Text & "dataset.xml")
        End If

        If Not (System.IO.File.Exists("c:\" & Label10.Text & "data.xml")) Then
            ds.WriteXml("c:\" & Label10.Text & "data.xml")
        Else
            ds.ReadXml("c:\" & Label10.Text & "data.xml")
            totalrows = dt.Rows.Count
            TextBox1.Text = totalrows
        End If

        currentrow = 0
        TextBox2.Text = currentrow

    End Sub

    Private Sub replacechannel()
        TextBox3.Text = dt.Rows(currentrow).Item(0)
        TextBox4.Text = dt.Rows(currentrow).Item(1)
    End Sub

    Private Sub Duration_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Duration.TextChanged
        currentrow = currentrow + 1

        If Play.Text = "Playing" And currentrow < totalrows Then
            findchannel()
            UProw()

        ElseIf Play.Text = "Playing" And currentrow > totalrows Then
            loadnewrow()
        End If

    End Sub

    Private Sub TextBox4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox4.TextChanged
        UpdateChekBox()
        'This is where we check the output string to see if it had Control Return and Line Feed (vbcrlf) 
        'if it does we send it if not we add it then send it to the serial port on Form 5.
        If SerialPort.IsOpen Then
            Dim SentText As String = TextBox1.Text
            If CreateStrg.EndsWith(vbCrLf) = False Then
                CreateStrg &= vbCrLf
            End If
            SerialPort.Write(CreateStrg)
        End If

    End Sub

    Private Sub Label8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label8.TextChanged
        If Not Label8.Text = "File Name" Then
            Panel1.Enabled = True
        End If
    End Sub

    Public Sub UpdateChekBox()

        outData = TextBox4.Text
        If Play.Text = "Playing" Then
            If outData(0) = "1" Then
                CheckBox1.CheckState = CheckState.Checked
            Else
                CheckBox1.CheckState = CheckState.Unchecked
            End If
            If outData(1) = "1" Then
                CheckBox2.CheckState = CheckState.Checked
            Else
                CheckBox2.CheckState = CheckState.Unchecked
            End If
            If outData(2) = "1" Then
                CheckBox3.CheckState = CheckState.Checked
            Else
                CheckBox3.CheckState = CheckState.Unchecked
            End If
            If outData(3) = "1" Then
                CheckBox4.CheckState = CheckState.Checked
            Else
                CheckBox4.CheckState = CheckState.Unchecked
            End If
            If outData(4) = "1" Then
                CheckBox5.CheckState = CheckState.Checked
            Else
                CheckBox5.CheckState = CheckState.Unchecked
            End If
            If outData(5) = "1" Then
                CheckBox6.CheckState = CheckState.Checked
            Else
                CheckBox6.CheckState = CheckState.Unchecked
            End If
            If outData(6) = "1" Then
                CheckBox7.CheckState = CheckState.Checked
            Else
                CheckBox7.CheckState = CheckState.Unchecked
            End If
            If outData(7) = "1" Then
                CheckBox8.CheckState = CheckState.Checked
            Else
                CheckBox8.CheckState = CheckState.Unchecked
            End If
            If outData(8) = "1" Then
                CheckBox9.CheckState = CheckState.Checked
            Else
                CheckBox9.CheckState = CheckState.Unchecked
            End If
            If outData(9) = "1" Then
                CheckBox10.CheckState = CheckState.Checked
            Else
                CheckBox10.CheckState = CheckState.Unchecked
            End If
            If outData(10) = "1" Then
                CheckBox11.CheckState = CheckState.Checked
            Else
                CheckBox11.CheckState = CheckState.Unchecked
            End If
            If outData(11) = "1" Then
                CheckBox12.CheckState = CheckState.Checked
            Else
                CheckBox12.CheckState = CheckState.Unchecked
            End If
            If outData(12) = "1" Then
                CheckBox13.CheckState = CheckState.Checked
            Else
                CheckBox13.CheckState = CheckState.Unchecked
            End If
            If outData(13) = "1" Then
                CheckBox14.CheckState = CheckState.Checked
            Else
                CheckBox14.CheckState = CheckState.Unchecked
            End If
            If outData(14) = "1" Then
                CheckBox15.CheckState = CheckState.Checked
            Else
                CheckBox15.CheckState = CheckState.Unchecked
            End If
            If outData(15) = "1" Then
                CheckBox16.CheckState = CheckState.Checked
            Else
                CheckBox16.CheckState = CheckState.Unchecked
            End If
            If outData(16) = "1" Then
                CheckBox17.CheckState = CheckState.Checked
            Else
                CheckBox17.CheckState = CheckState.Unchecked
            End If
            If outData(17) = "1" Then
                CheckBox18.CheckState = CheckState.Checked
            Else
                CheckBox18.CheckState = CheckState.Unchecked
            End If
            If outData(18) = "1" Then
                CheckBox19.CheckState = CheckState.Checked
            Else
                CheckBox19.CheckState = CheckState.Unchecked
            End If
            If outData(19) = "1" Then
                CheckBox20.CheckState = CheckState.Checked
            Else
                CheckBox20.CheckState = CheckState.Unchecked
            End If
            If outData(20) = "1" Then
                CheckBox21.CheckState = CheckState.Checked
            Else
                CheckBox21.CheckState = CheckState.Unchecked
            End If
            If outData(21) = "1" Then
                CheckBox22.CheckState = CheckState.Checked
            Else
                CheckBox22.CheckState = CheckState.Unchecked
            End If
            If outData(22) = "1" Then
                CheckBox23.CheckState = CheckState.Checked
            Else
                CheckBox23.CheckState = CheckState.Unchecked
            End If
            If outData(23) = "1" Then
                CheckBox24.CheckState = CheckState.Checked
            Else
                CheckBox24.CheckState = CheckState.Unchecked
            End If
            If outData(24) = "1" Then
                CheckBox25.CheckState = CheckState.Checked
            Else
                CheckBox25.CheckState = CheckState.Unchecked
            End If
            If outData(25) = "1" Then
                CheckBox26.CheckState = CheckState.Checked
            Else
                CheckBox26.CheckState = CheckState.Unchecked
            End If
            If outData(26) = "1" Then
                CheckBox27.CheckState = CheckState.Checked
            Else
                CheckBox27.CheckState = CheckState.Unchecked
            End If
            If outData(27) = "1" Then
                CheckBox28.CheckState = CheckState.Checked
            Else
                CheckBox28.CheckState = CheckState.Unchecked
            End If
            If outData(28) = "1" Then
                CheckBox29.CheckState = CheckState.Checked
            Else
                CheckBox29.CheckState = CheckState.Unchecked
            End If
            If outData(29) = "1" Then
                CheckBox30.CheckState = CheckState.Checked
            Else
                CheckBox30.CheckState = CheckState.Unchecked
            End If
            If outData(30) = "1" Then
                CheckBox31.CheckState = CheckState.Checked
            Else
                CheckBox31.CheckState = CheckState.Unchecked
            End If
            If outData(31) = "1" Then
                CheckBox32.CheckState = CheckState.Checked
            Else
                CheckBox32.CheckState = CheckState.Unchecked
            End If

        End If
    End Sub

    Private Sub Label10_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label10.TextChanged
        If Not Label10.Text = "Sequence Name" Then
            OpenMusicFileToolStripMenuItem.Enabled = True
            OpenMusic.Enabled = True
        End If
    End Sub

    Private Sub HowToGuideToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HowToGuideToolStripMenuItem.Click
        Form2.Show()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.MouseDown
        c1 = 1
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.MouseUp
        c1 = 0
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.MouseDown
        c2 = 1
    End Sub

    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.MouseUp
        c2 = 0
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.MouseDown
        c3 = 1
    End Sub

    Private Sub Button3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.MouseUp
        c3 = 0
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.MouseDown
        c4 = 1
    End Sub

    Private Sub Button4_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.MouseUp
        c4 = 0
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.MouseDown
        c5 = 1
    End Sub

    Private Sub Button5_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.MouseUp
        c5 = 0
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.MouseDown
        c6 = 1
    End Sub

    Private Sub Button6_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.MouseUp
        c6 = 0
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.MouseDown
        c7 = 1
    End Sub

    Private Sub Button7_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.MouseUp
        c7 = 0
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.MouseDown
        c8 = 1
    End Sub

    Private Sub Button8_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.MouseUp
        c8 = 0
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.MouseDown
        c9 = 1
    End Sub

    Private Sub Button9_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.MouseUp
        c9 = 0
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.MouseDown
        c10 = 1
    End Sub

    Private Sub Button10_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.MouseUp
        c10 = 0
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.MouseDown
        c11 = 1
    End Sub

    Private Sub Button11_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.MouseUp
        c11 = 0
    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.MouseDown
        c12 = 1
    End Sub

    Private Sub Button12_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.MouseUp
        c12 = 0
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.MouseDown
        c13 = 1
    End Sub

    Private Sub Button13_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.MouseUp
        c13 = 0
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.MouseDown
        c14 = 1
    End Sub

    Private Sub Button14_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.MouseUp
        c14 = 0
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.MouseDown
        c15 = 1
    End Sub

    Private Sub Button15_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.MouseUp
        c15 = 0
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.MouseDown
        c16 = 1
    End Sub

    Private Sub Button16_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.MouseUp
        c16 = 0
    End Sub

    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.MouseDown
        c17 = 1
    End Sub

    Private Sub Button17_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.MouseUp
        c17 = 0
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.MouseDown
        c18 = 1
    End Sub

    Private Sub Button18_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.MouseUp
        c18 = 0
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.MouseDown
        c19 = 1
    End Sub

    Private Sub Button19_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.MouseUp
        c19 = 0
    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.MouseDown
        c20 = 1
    End Sub

    Private Sub Button20_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.MouseUp
        c20=0
    End Sub

    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.MouseDown
        c21 = 1
    End Sub

    Private Sub Button21_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.MouseUp
        c21 = 0
    End Sub

    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.MouseDown
        c22 = 1
    End Sub

    Private Sub Button22_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.MouseUp
        c22 = 0
    End Sub

    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.MouseDown
        c23 = 1
    End Sub

    Private Sub Button23_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.MouseUp
        c23 = 0
    End Sub

    Private Sub Button24_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button24.MouseDown
        c24 = 1
    End Sub

    Private Sub Button24_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button24.MouseUp
        c24 = 0
    End Sub

    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.MouseDown
        c25 = 1
    End Sub

    Private Sub Button25_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.MouseUp
        c25 = 0
    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.MouseDown
        c26 = 1
    End Sub

    Private Sub Button26_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.MouseUp
        c26 = 0
    End Sub

    Private Sub Button27_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.MouseDown
        c27 = 1
    End Sub

    Private Sub Button27_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.MouseUp
        c27 = 0
    End Sub

    Private Sub Button28_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.MouseDown
        c28 = 1
    End Sub

    Private Sub Button28_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.MouseUp
        c28 = 0
    End Sub

    Private Sub Button29_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.MouseDown
        c29 = 1
    End Sub

    Private Sub Button29_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.MouseUp
        c29 = 0
    End Sub

    Private Sub Button30_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.MouseDown
        c30 = 1
    End Sub

    Private Sub Button30_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.MouseUp
        c30 = 0
    End Sub

    Private Sub Button31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.MouseDown
        c31 = 1
    End Sub

    Private Sub Button31_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.MouseUp
        c31 = 0
    End Sub

    Private Sub Button32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.MouseDown
        c32 = 1
    End Sub

    Private Sub Button32_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.MouseUp
        c32 = 0
    End Sub

    Private Sub Serial_Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Serial_Connect.Click
        If Serial_Connect.Text = "Connect Serial Port" Then
            If SerialPort.IsOpen Then
                SerialPort.Close()
            End If
            Try
                With SerialPort
                    .PortName = Port.Text
                    .BaudRate = Baud.Text
                    .Parity = a 'a is the variable from the checkboxes
                    .DataBits = Bits.Text
                    .StopBits = b 'same as a variable 
                    .Handshake = c 'same as a and b variable
                End With
                SerialPort.Open()
                Serial_Connect.Text = "Disconnect Serial Port"
                Label12.Text = "Connected"
                ToolStripStatusLabel1.Text = "Serial Port " & Port.Text & _
 " Connected at " & Baud.Text & " Baud"
                Port.Enabled = False
                Baud.Enabled = False
                Bits.Enabled = False
                Odd.Enabled = False
                Even.Enabled = False
                None.Enabled = False
                Bit1.Enabled = False
                Bit2.Enabled = False
                Flow_Hardware.Enabled = False
                Flow_None.Enabled = False
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        ElseIf Serial_Connect.Text = "Disconnect Serial Port" Then
            SerialPort.Close()
            Serial_Connect.Text = "Connect Serial Port"
            ToolStripStatusLabel1.Text = "Comm Port Status"
            Label12.Text = "Not Connected"
            Port.Enabled = True
            Baud.Enabled = True
            Bits.Enabled = True
            Odd.Enabled = True
            Even.Enabled = True
            None.Enabled = True
            Bit1.Enabled = True
            Bit2.Enabled = True
            Flow_Hardware.Enabled = True
            Flow_None.Enabled = True
        End If
    End Sub

    Private Sub None_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles None.CheckedChanged
        If None.Checked = True Then
            Odd.Checked = False
            Even.Checked = False
            a = 0
        End If
    End Sub

    Private Sub Odd_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Odd.CheckedChanged
        If Odd.Checked = True Then
            Even.Checked = False
            None.Checked = False
            a = 1
        End If
    End Sub

    Private Sub Even_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Even.CheckedChanged
        If Even.Checked = True Then
            Odd.Checked = False
            None.Checked = False
            a = 2
        End If
    End Sub

    Private Sub Bit1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bit1.CheckedChanged
        If Bit1.Checked = True Then
            Bit2.Checked = False
            b = 1
        End If

    End Sub

    Private Sub Bit2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bit2.CheckedChanged
        If Bit2.Checked = True Then
            Bit1.Checked = False
            b = 2
        End If

    End Sub

    Private Sub Flow_Hardware_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Flow_Hardware.CheckedChanged
        If Flow_Hardware.Checked = True Then
            Flow_None.Checked = False
            c = 2
        End If
    End Sub

    Private Sub Flow_None_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Flow_None.CheckedChanged
        If Flow_None.Checked = True Then
            Flow_Hardware.Checked = False
            c = 0
        End If
    End Sub

End Class
